=== debian/changelog ===
telegram-desktop (2.2.0+ds-3ubuntu1) hirsute; urgency=medium

  * Build with system QtWayland private headers.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sat, 28 Nov 2020 11:55:18 +0300

telegram-desktop (2.2.0+ds-3) unstable; urgency=medium

  * Add private headers from qtwayland-opensource-src of version 5.15.1-1.
  * New patches:
    - Packed-resources.patch puts app resources into a separate .rcc file.
    - No-random-popups.patch introduces an internal flag to deactivate some
      menus that popup suddenly.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Wed, 30 Sep 2020 08:40:37 +0300

telegram-desktop (2.2.0+ds-2) unstable; urgency=medium

  * Fix build against updated mapbox-variant 1.2.0.
  * Build without Wayland integration on non-Linux.
  * Minor housekeeping in package build rules.
  * Refresh package documentation.
    - Update patch headers to reflect present situation.
    - Update man page telegram-desktop(1).
    - Add d/README.source.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Tue, 01 Sep 2020 19:13:39 +0300

telegram-desktop (2.2.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Remove no longer needed patches:
     - Checks-for-libatomic.patch, now libatmoic is linked unconditionally.
     - Debug-info-for-32-bit.patch, no forced -g0 for packaged build.
     - Unset-Qt-platform-theme.patch, incorporated info upstream source code.
  * Modified remained patches:
     - Path-to-libtgvoip.patch has been renamed to Static-libtgvoip.patch to
       reflect changes for new libtgvoip.
     - Do-not-sync-wallpaper.patch has been just refreshed against new source.
  * Import QtWaylandClient private headers from the qtwayland-opensource-src
    package of version 5.14.2-2.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Tue, 28 Jul 2020 09:27:12 +0300
